<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>parameters - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="Image.html">Image</a><ul class='methods'><li data-type='method' style='display: none;'><a href="Image.html#get">get</a></li><li data-type='method' style='display: none;'><a href="Image.html#set">set</a></li></ul></li><li><a href="parameters.html">parameters</a></li></ul>
</nav>

<div id="main">
    
    <h1 class="page-title">parameters</h1>
    

    




<section>

<header>
    
        <h2>
        parameters
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="parameters"><span class="type-signature"></span>factory parameters<span class="type-signature"></span></h4>

    




<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>Setter parameters for commands.</p>
<ul>
<li>
<p><a href="#introduction">General mechanism</a></p>
</li>
<li>
<p><a href="#commands">Available commands</a></p>
<ul>
<li><a href="#grab">grab</a> Grabs an image from a source device.</li>
<li><a href="#load">load</a> Loads an image from a source file.</li>
<li><a href="#save">save</a> Saves an image in files.</li>
<li><a href="#cache">cache</a> Caches an image in memory.</li>
<li><a href="#copy">copy</a> Copies an image from a source image.</li>
<li><a href="#crop">crop</a> Crops a rectangle image from a source image.</li>
<li><a href="#rectify">rectify</a> Crops a quadrilateral from a source image.</li>
<li><a href="#intensity">intensity</a> Calculates image intensity statistics.</li>
<li><a href="#histogram">histogram</a> Calculates image histograms.</li>
<li><a href="#similarity">similarity</a> Computes the similarity with respect to a source image.</li>
<li><a href="#balance">balance</a> Balances the image intensity.</li>
<li><a href="#median">median</a> Smooths the image intensity.</li>
<li><a href="#fovea">fovea</a> Defines a foveal mask of transparency to limit image border influence.</li>
<li><a href="#resize">resize</a> Resizes an image.</li>
<li><a href="#bgr">bgr</a> Converts the Blue-Green-Red input in float format.</li>
<li><a href="#hsv">hsv</a> Computes the Hue-Saturation-Value input in float format.</li>
<li><a href="#smooth">smooth</a> Smooths the input using an exponential filter in float format.</li>
<li><a href="#edge">edge</a> Computes the image edges in float format.</li>
<li><a href="#subtract">subtract</a> Subtracts a background from this image.</li>
<li><a href="#blob">blob</a> Thresholds a colored blob in this image.</li>
<li><a href="#segment">segment</a> Segments and parse blobs in this image.</li>
<li><a href="#match">match</a> Matches the image against source·s images.</li>
<li><a href="#draw">draw</a> Draws elements on a copy of this image input.</li>
<li><a href="#show">show</a> Displays channel·s in popup window·s.</li>
</ul>
</li>
<li>
<p><a href="#bugs">Caution about bug and caveat</a></p>
</li>
</ul>
<h2>General mechanism  <a name="introduction"></a></h2>
<ul>
<li>Each command is defined by:
<ul>
<li>A name given in the <code>do</code> field.</li>
<li>A set of input parameters, stored in the Image parameters under the command name on output.</li>
</ul>
</li>
</ul>
<p><em>Remarks</em>:</p>
<ul>
<li>Each command is designed to be applied once on an Image, otherwise image copied is to advised.</li>
<li>Other mechanisms can be implemented via the <a href="https://gitlab.inria.fr/line/aide-group/aidecv/-/blob/master/src/Setter.hpp">Setter</a> hook.</li>
</ul>
<h2>Available commands  <a name="commands"></a></h2>
<ul>
<li>
<p><a name="grab"></a> <strong>[grab]</strong> <code>{ do: grad device: $device-index }</code> or <code>$device-index</code>.</p>
<ul>
<li>Grabs a RGB image from an input device.</li>
<li><em>Input parameter</em>:
<ul>
<li>The <code>device</code> index, it can simply be given as a string, without JSON construct.
<ul>
<li>0,1,2,3 corresponds to the <em>/dev/video$device-number</em> device.</li>
<li>4  On a RPi, it corresponds to the 1280x960 resolution PiCamera.</li>
<li>5  On a RPi, it corresponds to the full-resolution PiCamera using the <em>raspistill</em> utility.</li>
</ul>
</li>
<li><code>clear</code>: if not false image channels and parameters are beforehand cleared.</li>
</ul>
</li>
<li><em>Output channel</em>: The raw <code>input</code> image, in <code>CV_8UC3</code> format.</li>
<li><em>Output parameters</em>: Image <code>width</code> and <code>height</code>.</li>
</ul>
</li>
<li>
<p><a name="load"></a> <strong>[load]</strong> <code>{ do: load file: $image-file-name }</code> or <code>$image-file-name</code>.</p>
<ul>
<li>Loads a RGB image from, e.g. a <code>.png</code> or other standard file format.</li>
<li><em>Input parameter</em>:
<ul>
<li>The <code>file</code> name, it can simply be given without JSON construct.</li>
<li>If the <code>alpha: true</code> option is present, an <code>alpha</code> transparency <code>CV_8UC1</code> channel is added, in any case.</li>
<li><code>clear</code>: if not false image channels and parameters are beforehand cleared.</li>
</ul>
</li>
<li><em>Output channel</em>: The raw <code>input</code> image, in <code>CV_8UC3</code> format.
<ul>
<li>If transparency is present, a separate <code>alpha</code> transparency <code>CV_32SC1</code> channel is loaded, unless setting <code>alpha: false</code>.</li>
</ul>
</li>
<li><em>Output parameters</em>: Image <code>width</code> and <code>height</code>.</li>
</ul>
</li>
<li>
<p><a name="save"></a> <strong>[save]</strong> <code>{ do: save path: $image-files-directory }</code>.</p>
<ul>
<li>Saves all image channels and parameters in the target directory <code>path</code>.</li>
<li><em>Input parameter</em>:
<ul>
<li>The <code>path</code>, files directory where to store the images.</li>
</ul>
</li>
<li><em>Output</em>: A <code>path</code> directory with
<ul>
<li>All cv::Mat images stored under their name.
<ul>
<li>Pixel images (i.e., 3 channels <code>CV_8U</code> image) are stored as <code>.png</code> image.</li>
<li>The <code>alpha</code> channel is stored in a distinct <code>CV_8C1</code> <code>.png</code> image.</li>
<li>Index images (i.e., 1 channel <code>CV_32S</code> image) are stored as floating point <code>.exr</code> images.</li>
<li>Floating point numeric images (i.e., <code>CV_32F</code> images) are stored as either 1 or 3 channel·s <code>.exr</code> images.</li>
</ul>
</li>
<li>The <code>path/parameters.json</code> file contains all parameters
<ul>
<li>Including <code>channels</code> listing each <code>cv::Mat</code> data structure channel parameters.</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li>
<p><a name="cache"></a> <strong>[cache]</strong> <code>{ do: cache name: ... what: (get|put|del[ete])}</code>.</p>
<ul>
<li>Stores this image in a cache in order to use it as a source for other image processing.</li>
<li><em>Input parameter</em>:
<ul>
<li>The unique <code>name</code> of the image image in the cache.</li>
<li>Defines <code>what</code> is to be done:
<ul>
<li><code>put</code>: to put an image into the cache (default if the image name is undefined).
<ul>
<li>If an image is previously defined, it is erased by this operation.</li>
</ul>
</li>
<li><code>get</code>: to copy an image from the cache into this image (default if the image name is defined).
<ul>
<li><code>clear</code>: if not false image channels and parameters are beforehand cleared.</li>
</ul>
</li>
<li><code>del</code> or <code>delete</code>: to delete an image which is in the cache.</li>
</ul>
</li>
</ul>
</li>
<li><em>Output channels</em>: When <code>get</code>, all channels defined in the <code>cache</code> image.</li>
<li><em>Output parameters</em>: When <code>get</code>, the <code>cache</code> image parameters.</li>
</ul>
</li>
<li>
<p><a name="copy"></a> <strong>[copy]</strong> <code>{ do: copy }</code>.</p>
<ul>
<li>Copies all channels of the <code>source</code> image into this image.
<ul>
<li>The <code>source</code> image defined either:
<ul>
<li>Using the <code>set(JSON parameters, const Image&amp; source)</code> 2nd argument.</li>
<li>Or defining a <code>{ do: copy source: name}</code> parameter, getting the image from the cache by its name.</li>
</ul>
</li>
<li>This is the default operation if no parameter is given.</li>
</ul>
</li>
<li><em>Input parameter</em>:
<ul>
<li><code>clear</code>: if not false image channels and parameters are beforehand cleared.</li>
</ul>
</li>
<li><em>Input channels</em>: The source channels.</li>
<li><em>Output channels</em>: All channels defined in the <code>source</code> image.</li>
<li><em>Output parameters</em>: The <code>source</code> image parameters.</li>
</ul>
</li>
<li>
<p><a name="crop"></a> <strong>[crop]</strong> <code>{ do: crop, top: ..., right: ..., bottom: ..., left: ...}</code></p>
<ul>
<li>Crops a rectangular part of the <code>source</code> image into this target image.</li>
<li><em>Input channel</em>: The source raw <code>input</code> image, in <code>CV_8UC3</code> format.
<ul>
<li>The <code>source</code> image defined either by the <code>set()</code> 2nd argument or using a <code>source</code> parameter, as for <code>{do: copy ...</code>.</li>
</ul>
</li>
<li><em>Input parameters</em>:
<ul>
<li><code>clear</code>: if not false image channels and parameters are beforehand cleared.</li>
<li><code>top</code>: Crop rectangle top vertical position, default is 0.</li>
<li><code>right</code>: Crop rectangle right horizontal position, default is image.width-1.</li>
<li><code>bottom</code>: Crop rectangle bottom vertical position, default is image.height-1.</li>
<li><code>left</code>: Crop rectangle left horizontal position, default is 0.</li>
</ul>
</li>
<li><em>Output channel</em>: The raw <code>input</code> image, in <code>CV_8UC3</code> format.</li>
</ul>
</li>
<li>
<p><a name="rectify"></a> <strong>[rectify]</strong> <code>{ do: rectify, top_x: ..., top_y: ..., ...}</code></p>
<ul>
<li>Crops a quadrilateral of the <code>source</code> image into this target image, applying a perspective transform.</li>
<li><em>Input channel</em>: The source raw <code>input</code> image, in <code>CV_8UC3</code> format.
<ul>
<li>The <code>source</code> image defined either by the <code>set()</code> 2nd argument or using a <code>source</code> parameter, as for <code>{do: copy ...</code>.</li>
</ul>
</li>
<li><em>Input parameters</em>:
<ul>
<li><code>clear</code>: if not false image channels and parameters are beforehand cleared.</li>
<li><code>top_x</code>: The crop top horizontal position, in pixel, default is 0.</li>
<li><code>top_y</code>: The crop top vertical position, in pixel, default is 0.</li>
<li><code>right_x</code>: The crop right horizontal position, in pixel, default is image.width-1.</li>
<li><code>right_y</code>: The crop right vertical position, in pixel, default is 0.</li>
<li><code>bottom_x</code>: The crop top horizontal position, in pixel, default is image.width-1.</li>
<li><code>bottom_y</code>: The crop top vertical position, in pixel, default is image.height-1.</li>
<li><code>left_x</code>: The crop top horizontal position, in pixel, default is 0.</li>
<li><code>left_y</code>: The crop top vertical position, in pixel, default is image.height-1.</li>
<li><code>width</code>: The final image width, default is the image width.</li>
<li><code>height</code>: The final image height, default, default is the image height, or the width if specified.</li>
</ul>
</li>
<li><em>Output channel</em>: The raw <code>input</code> image, in <code>CV_8UC3</code> format.</li>
</ul>
</li>
<li>
<p><a name="intensity"></a> <strong>[intensity]</strong></p>
<ul>
<li>Calculates image intensity basic statistics, all blue, green and red values together</li>
<li><em>Output parameters</em>: basic intensity statistical values:
<ul>
<li><code>median</code> (image BGR intensity median intensity)</li>
<li><code>lower-quartile</code></li>
<li><code>upper-quartile</code></li>
<li><code>minimum</code></li>
<li><code>maximum</code></li>
<li><code>mode</code></li>
<li><code>mode-count</code> (number of pixels with the mode value)</li>
<li><code>mean</code></li>
<li><code>stdev</code> (standard-deviation)</li>
<li><code>entropy</code> (intensity histogram entropy, between 0 and 8 bits for the 256 values)</li>
<li><code>bin-count</code> (optimla histogram bin count according to <a href="https://en.wikipedia.org/wiki/Histogram#Scott's_normal_reference_rule">Scott rule</a>.</li>
</ul>
</li>
</ul>
</li>
<li>
<p><a name="histogram"></a> <strong>[histogram]</strong></p>
<ul>
<li>Calculates image channel histograms:</li>
<li><em>Input parameters</em>:
<ul>
<li><code>what</code>: a sequence of unordered letter (default is all).
<ul>
<li><code>B</code>: for the blue channel.</li>
<li><code>G</code>: for the green channel.</li>
<li><code>R</code>: for the red channel.</li>
<li><code>H</code>: for the hue channel.</li>
<li><code>T</code>: for the tint channel histogram, i.e. the hue channel weighted by the saturation.</li>
<li><code>S</code>: for the saturation channel.</li>
<li><code>V</code>: for the value channel.</li>
<li><code>C</code>: for the contrast, i.e., the edge magnitude channel.</li>
<li><code>O</code>: for the orientation, i.e., the edge orientation channel.</li>
</ul>
</li>
<li><code>window</code>: 1D smoothing window to avoid &quot;sparse&quot; histogram, default is none.</li>
<li><code>proba</code>: If true, normalizes in order the sum of the values to be equal to 1.</li>
<li><code>median</code>: If true, calculates the histogram median value in <code>target.get().[&quot;histogram&quot;][what][&quot;median&quot;]</code> where <code>what</code> is the choosen channel.
<ul>
<li>The bin of value 0 is not taken into account, to avoid low value masking.</li>
<li>If a circular value is considered (i.e., an angle), this value is biased.</li>
</ul>
</li>
<li><code>mode</code>: If true, calculates the histogram mode value in <code>target.get().[&quot;histogram&quot;][what][&quot;mode&quot;]</code> where <code>what</code> is the choosen channel.
<ul>
<li>The bin of value 0 is not taken into account, to avoid low value masking.</li>
</ul>
</li>
<li><code>smooth</code>: 1D histogram smoothing window to smooth histograms, default is 0 (no smoothing).
<ul>
<li>The bin of value 0 is not smoothed, to avoid low value masking.</li>
<li>For circular value, circular recursive smoothing is applied.</li>
</ul>
</li>
<li><code>draw</code>: either <code>lin</code> or <code>log</code> to draw the histogram with a linear or logarithmic scale (it applies only to the plot, the histogram remains unchanged).
<ul>
<li><code>blue</code>: The blue channel.</li>
<li><code>green</code>: The green channel.</li>
<li><code>red</code>: The red channel.</li>
<li><code>magenta</code>: The <a href="https://en.wikipedia.org/wiki/Hue">hue</a> channel.</li>
<li><code>pink</code>: The tint channel.</li>
<li><code>yellow</code>: The saturation channel.</li>
<li><code>white</code>: The value channel.</li>
<li><code>gray</code>: The edge amplitude channel.</li>
<li><code>cyan</code>: The edge orientation channel.</li>
</ul>
</li>
</ul>
</li>
<li><em>Output channels</em>:
<ul>
<li>The <code>histogram-$letter</code> where <code>$letter</code> stands for the channel letter <code>B</code>, <code>R</code>, <code>G</code>, <code>H</code>, <code>S</code>, <code>V</code>, <code>C</code>, <code>O</code> with the histogram as a, in <code>CV_32FC1</code> format.</li>
<li>The <code>histogram-$letter-view</code> the histogram plots as an image, in <code>CV_8UC3</code> format, if <code>draw</code> is defined.</li>
</ul>
</li>
</ul>
</li>
<li>
<p><a name="similarity"></a> <strong>[similarity]</strong> <code>{do: similarity similarity: correlation ...</code></p>
<ul>
<li>Calculates the similirity with respect to the source image</li>
<li><em>Input channels</em>:
<ul>
<li>This image channels, depending on the metric.</li>
<li>The <code>source</code> image defined either by the <code>set()</code> 2nd argument or using a <code>source</code> parameter, as for <code>{do: copy ...</code>.</li>
<li>The <code>alpha</code> channel if present in the source image is used as a weighting.</li>
<li>Input image pixel value at <code>255</code> are not taken into account (they are either saturated values or border values).</li>
</ul>
</li>
<li><em>Input parameters</em>:
<ul>
<li><code>similarity</code>: the choosen similarity estimation
<ul>
<li><code>correlation</code>: Uses the <a href="./Image.pdf#page=7">normalized correlation</a> between the two images intensities. Returns a value in <code>[0, 4]</code>, <code>0</code> if entirely correlated, <code>2</code> if uncorrelated, <code>4</code> if entirely anti-correlated.</li>
<li>Other metric can be implemented via the <a href="https://gitlab.inria.fr/line/aide-group/aidecv/-/blob/master/src/Metric.hpp">Metric</a> hook.</li>
</ul>
</li>
</ul>
</li>
<li><em>Output parameters</em>:
<ul>
<li><code>value</code>: The similarity value, a non-negative value, equal to <code>0</code> if similarity is maximal.</li>
</ul>
</li>
</ul>
</li>
<li>
<p><a name="balance"></a> <strong>[balance]</strong> <code>{ do: balance, saturation: ... }</code></p>
<ul>
<li>Balances the image intensity with respect to white.</li>
<li><em>Input parameters</em>:
<ul>
<li><code>balance</code>: Method, either <code>simple</code> (default) or <code>grayworld</code> (or <code>learned</code>), as <a href="https://docs.opencv.org/3.4/d9/dcd/white__balance_8hpp.html">defined in opencv</a>.</li>
<li><code>saturation</code>:
<ul>
<li><code>simple</code> case: Percent of top/bottom values to ignore, default is <code>2</code>.</li>
<li><code>grayworld</code> or <code>learned</code> case: Maximum saturation for a pixel to be included in the gray-world assumption, default is 0.9.</li>
</ul>
</li>
<li><code>equalize</code>: If true performs an BGR histogram equalization after balance.</li>
</ul>
</li>
<li><em>Input/Output channel</em>: The <code>input</code> image with white balance performed.</li>
</ul>
</li>
<li>
<p><a name="median"></a> <strong>[median]</strong> <code>{do: smooth window: ...}</code></p>
<ul>
<li>Computes a smoothed version of this image using a median filter.</li>
<li><em>Input parameters</em>:
<ul>
<li><code>window</code> The smoothing filter window size in pixel, typically <code>3</code> (default), <code>5</code> or <code>7</code>.</li>
</ul>
</li>
<li><em>Input/Output channel</em>: The <code>input</code> image with median filtered performed.</li>
</ul>
</li>
<li>
<p><a name="fovea"></a> <strong>[fovea]</strong> <code>{ do: fovea, }</code></p>
</li>
<li>
<p>Defines a foveal mask of transparency to limit image border influence.</p>
</li>
<li>
<p>Implements a fixed quadratic separable profile.</p>
</li>
<li>
<p><em>Input/Output channel</em>: The <code>alpha</code> transparency <code>CV_8UC1</code> channel, modulated in existant, created otherwise.</p>
</li>
<li>
<p><a name="resize"></a> <strong>[resize]</strong> <code>{ do: resize, width: ..., height: ... }</code></p>
<ul>
<li>Resizes all channel of this image to the given sizes, or to the source image sizes (<em>without</em> copying the source image).</li>
<li><em>Input parameters</em>:
<ul>
<li><code>width</code>: Image width, default is the source image width if any, else unchanged.</li>
<li><code>height</code>: Image height, default is the source image height if any, else unchanged</li>
</ul>
</li>
<li><em>Output parameters</em>: The new <code>width</code> and <code>height</code>.</li>
<li><em>Input/Output channel</em>: All image channels at the new size.</li>
</ul>
</li>
<li>
<p><a name="bgr"></a> <strong>[bgr]</strong> <code>{ do: bgr }</code> or <code>bgr</code>.</p>
<ul>
<li>Computes the image as a <code>CV_32FC3</code> 3 channels float.</li>
<li><em>Input channel</em>: The <code>input</code> raw image in <code>CV_8UC3</code> format.</li>
<li><em>Output channel</em>: A raw <code>bgr</code> blue-green-red image, in <code>CV_32FC3</code> format, with values in <code>[0, 1]</code>.</li>
</ul>
</li>
<li>
<p><a name="hsv"></a> <strong>[hsv]</strong> <code>{ do: hsv }</code> or <code>hsv</code>.</p>
<ul>
<li>Computes the image <a href="https://docs.opencv.org/3.4/de/d25/imgproc_color_conversions.html">RGB-&gt;HSV color conversion</a>, as a <code>CV_32FC3</code> 3 channels float.
<ul>
<li>The <a href="https://en.wikipedia.org/wiki/Hue">hue</a> angular value stands between 0deg and 360deg</li>
<li>The saturation relative value stands between 0 and 1</li>
<li>The (maximal intensity) value stands between 0 and 1</li>
</ul>
</li>
<li><em>Input channel</em>: The <code>bgr</code> blue-green-red image, in <code>CV_32FC3</code> format.</li>
<li><em>Output channel</em>: A raw <code>hsv</code> hue-saturation-value image, in <code>CV_32FC3</code> format.</li>
</ul>
</li>
<li>
<p><a name="smooth"></a> <strong>[smooth]</strong> <code>{do: smooth window: ...}</code></p>
<ul>
<li>Computes a smoothed version of this image using a <a href="./Image.pdf#page=2">1st order exponential recursive filter</a>, as a <code>CV_32FC3</code> 3 BGR channels float.</li>
<li><em>Input channel</em>: The <code>bgr</code> blue-green-red image, in <code>CV_32FC3</code> format.</li>
<li><em>Input parameters</em>:
<ul>
<li><code>window</code>: The smoothing filter window size in pixel, with 90% of the signal to be in a the pixel window.</li>
</ul>
</li>
<li><em>Output channel</em>: A <code>smooth</code> blue-green-red image, in <code>CV_32FC3</code> format.</li>
</ul>
</li>
<li>
<p><a name="edge"></a> <strong>[edge]</strong> <code>{do: edge window: ...}</code></p>
<ul>
<li>Computes a the local edge characteristics.
<ul>
<li>Magnitude: the edge magnitude, from 0 to 255, in pixel value.</li>
<li>Orientation: the edge orientation, from 0 to 360 degree.</li>
</ul>
</li>
<li>It is based on the local intensity derivative <a href="https://en.wikipedia.org/wiki/Singular-value_decomposition">SVD</a> we obtain the <a href="./Image.pdf#page=3">color edge eigen elements</a>, using a smoothed image.</li>
<li><em>Input channel</em>: The <code>smooth</code> blue-green-red image, in <code>CV_32FC3</code> format.</li>
<li><em>Input parameters</em>:
<ul>
<li><code>window</code> The smoothing filter window size in pixel, with 90% of the signal to be in a the pixel window.</li>
</ul>
</li>
<li><em>Output channel</em>: A <code>edge</code> intensity-orientation image, in <code>CV_32FC2</code> format, the 3rd channel not being used.</li>
</ul>
</li>
<li>
<p><a name="subtract"></a> <strong>[subtract]</strong> <code>{ do: subtract, threshold: ..., slope: ...}</code></p>
<ul>
<li>Background thresholds this image, considering the <code>source</code> image as background.</li>
<li><em>Input channel</em>:
<ul>
<li>The source raw <code>input</code> image, in <code>CV_8UC3</code> format.</li>
<li>The <code>source</code> image defined either by the <code>set()</code> 2nd argument or using a <code>source</code> parameter, as for <code>{do: copy ...</code>.</li>
</ul>
</li>
<li><em>Input parameters</em>:
<ul>
<li><code>threshold</code>: The intensity threshold above which it is not in the background, default is <code>50</code>.</li>
<li><code>mode</code>: The threshold mechanism:
<ul>
<li><code>step</code>: To set to zero values below a given BGR threshold (default).</li>
<li><code>weak</code>: To progressively reduce the intensity below a given BGR threshold.</li>
</ul>
</li>
</ul>
</li>
<li><em>Input/Output channels</em>:
<ul>
<li>The <code>input</code> image with the multiplicative subtraction done, in <code>CV_8UC3</code> format.</li>
<li>The <code>substract</code> image with a copy of the input image before substraction, in <code>CV_8UC3</code> format.</li>
</ul>
</li>
</ul>
</li>
<li>
<p><a name="blob"></a> <strong>[blob]</strong> <code>{do: blob blue: ... green: ... red: ... ... }</code></p>
<ul>
<li>Detects color blobs in the image.</li>
<li>The HSV <a href="https://docs.opencv.org/3.4/de/d25/imgproc_color_conversions.html">color conversion</a> is considered:</li>
<li>The pixel hue, intensity and color saturation are taken into account.</li>
<li>The method is derived from <a href="https://docs.opencv.org/3.4/da/d97/tutorial_threshold_inRange.html">here</a> and <a href="https://docs.opencv.org/trunk/df/d9d/tutorial_py_colorspaces.html">there</a>.</li>
<li><em>Input channel</em>: The raw <code>hsv</code> hue-saturation-value image, in <code>CV_32FC3</code> format.</li>
<li><em>Input parameters</em>:
<ul>
<li><code>name</code>: The channel name for subsequent invocation to this blob.</li>
<li><code>blue</code>: The blob median blue color, between 0 and 255, default is 128.</li>
<li><code>green</code>: The blob median green color, between 0 and 255, default is 128.</li>
<li><code>red</code>: The blob median red color, between 0 and 255, default is 128.</li>
<li><code>hue_threshold</code>: The color hue threshold, in degree, in [0deg, 180deg], values in [hue_blob - hue_threshold, hue_blob + hue_threshold] are considered, default is 10deg.</li>
<li><code>saturation_threshold</code>: The color saturation minimal value, in percentage, values between [saturation_threshold, 100%] are considered, default is 0%.</li>
<li><code>value_threshold</code>: The intensity minimal value, values between [intensity_threshold, 255] are considered, default is 0.</li>
</ul>
</li>
<li><em>Output channel</em>: A <code>blob</code> integer mask as a <code>CV_32SC1</code> image with:
<ul>
<li><code>1</code>: for blob pixel value,</li>
<li><code>0</code>: for non-blob pixel value.</li>
</ul>
</li>
</ul>
</li>
<li>
<p><a name="segment"></a> <strong>[segment]</strong> <code>{do: segment input:... ... }</code></p>
<ul>
<li>
<p><em>Input channel</em>: An integer mask as a <code>CV_32SC1</code> image.</p>
</li>
<li>
<p><em>Input parameters</em>:</p>
<ul>
<li><code>input</code>: The input mask channel, segments image blobs according to the <code>blog_threshold</code> or <code>background_threshold</code> input channel <code>CV_32S1</code> integer channel information.
<ul>
<li>Adjacent pixel of the same region have the same non-negative value in the mask.</li>
<li>Negative values corresponds to unlabeled pixels to be included in the closest indexed region.</li>
</ul>
</li>
<li><code>size_threshold</code>: The minimal pixel count of a blob, default is 100.</li>
<li><code>draw</code>: If defined draw the blobs on a <code>output</code> BGR image, specifying what is to be drawn, any bitwise combination of:</li>
<li><code>0x01</code>: Draws the &quot;name&quot; (or &quot;index&quot; if &quot;name&quot; is undefined) as a text around the blob center (&quot;x&quot;, &quot;y&quot;).</li>
<li><code>0x02</code>: Draws a '+' cross on the blob center (&quot;x&quot;, &quot;y&quot;) with a length related to the &quot;size&quot;.</li>
<li><code>0x04</code>: Draws a rectangle from the blob &quot;top&quot;, &quot;right&quot;, &quot;bottom&quot;, &quot;left&quot;, border.</li>
<li><code>0x08</code>: Draws an ellipse of center (&quot;x&quot;, &quot;y&quot;), angle &quot;a&quot;, and axes length (&quot;L&quot;, &quot;l&quot;)</li>
<li><code>0x10</code>: Draws the pixels corresponding to the blob, using the blob average intensity.</li>
<li><code>0x20</code>: Draws the pixels corresponding to the blob, using a gray color.</li>
</ul>
</li>
<li>
<p><em>Output parameters</em>: In <code>segment/blobs</code>, a list of blobs, in size decreasing order, each blob defined by:</p>
<ul>
<li><code>index</code>: The blob index, form 0 number of pixels.</li>
<li><code>size</code>: The blob number of pixels.</li>
<li><code>x</code>: The blob horizontal median position, in pixel.</li>
<li><code>y</code>: The blob vertical median position, in pixel.</li>
<li><code>a</code>: The blob main orientation, in degree.</li>
<li><code>L</code>: The blob 2nd larger axis length.</li>
<li><code>l</code>: The blob 2nd smaller axis length.</li>
<li><code>e</code>: The blob thinness, from 0% if circular to 100% if filiform.</li>
<li><code>top</code>: The blob top minimal vertical position, in pixel.</li>
<li><code>right</code>: The blob right maximal horizontal position, in pixel.</li>
<li><code>bottom</code>: The blob bottom maximal vertical position, in pixel.</li>
<li><code>left</code>: The blob left minimal horizontal position, in pixel.</li>
<li><code>blue</code>: The average blob intensity blue value.</li>
<li><code>green</code>: The average blob intensity green value.</li>
<li><code>red</code>: The average blob intensity red value.</li>
</ul>
</li>
<li>
<p><em>Output channels</em>:</p>
<ul>
<li><code>segment</code>: Generates a <code>CV_32SC1</code> integer index map with a non-negative index to label each detected region.</li>
<li><code>output</code>: Generates a <code>CV_8UC2</code> image with the blobs drawn if the input parameter is defined.</li>
</ul>
</li>
<li>
<p>Algorithm details:</p>
<ul>
<li>Segments an image according to <a href="./Image.pdf#page=5">a standard colorization algorithm</a>.</li>
<li>Adjacent pixels in 8-connectivity (horizontal or vertical, and oblique) belongs to the same region.</li>
</ul>
</li>
</ul>
</li>
<li>
<p><a name="match"></a> <strong>[match]</strong> <code>{do: match transform: [{ ../..}], source: ..}</code></p>
<ul>
<li>Matches the source image·s with this image optimizing the given transform with respect to normalized correlation.</li>
<li><em>Input channels</em>:
<ul>
<li>This image &quot;input&quot; channel.</li>
<li>The <code>source</code> image defined either by the <code>set()</code> 2nd argument or using a <code>source</code> parameter, as for <code>{do: copy ...</code>.</li>
</ul>
</li>
<li><em>Input parameters</em>:
<ul>
<li><code>parameters</code>: The <a href="./Image.pdf#page=8">parameters</a> sequence, a <a href="https://line.gitlabpages.inria.fr/aide-group/stepsolver/Numeric.html">numeric</a> structure of the form:</li>
</ul>
</li>
</ul>
</li>
</ul>
<pre class="prettyprint source"><code>[
  {
    translation_i: { eps: 1    min: -width  max: width  step: 20 unit: pixel  }
    translation_j: { eps: 1    min: -height max: height step: 20 unit: pixel  }
    rotation:      { eps: 0.01 min: -10     max: 10     unit: radian }
    zoom:          { eps: 0.01 min: 0.1     max: 10 zero: 1 }
    warp:          { eps: 0.01 min: -10     max: 10 }
    twist:         { eps: 0.01 min: -10     max: 10 }
  }
  // Other multi-scale mapping process
]
</code></pre>
<ul>
<li>
<p><em>Output parameters</em>:</p>
<ul>
<li><code>similarity</code>: the best obtained similarity.</li>
<li><code>transform</code>: the best <a href="./Image.pdf#page=8">transform</a> parameters: <code>translation</code>: [t_x, t_y] in pixel, <code>rotation</code>: in linearized radian, <code>zoom</code>: in image ratio (<code>1</code> if no zoom), <code>warp</code> and <code>twist</code>.</li>
<li><code>results</code>: The input parameters adjusted after matching.</li>
</ul>
</li>
<li>
<p><a name="draw"></a> <strong>[draw]</strong> <code>{ do: draw, what: ... }</code></p>
<ul>
<li>
<p>Draws 2D elements on a copy of the input image.</p>
</li>
<li>
<p><em>Input channel</em>: The source raw <code>input</code> image, in <code>CV_8UC3</code> format.</p>
</li>
<li>
<p><em>Input parameters</em>:</p>
<ul>
<li><code>what</code>: A list of 2D elements of the form:
<ul>
<li><code>{do: text x:... y:... text:... color:...}</code> for a text <code>text</code> at a given position <code>(x,y)</code>.</li>
<li><code>{do: cross x:... y:... l:... color:...}</code> for a <code>+</code> cross at <code>(x,y)</code> and of length <code>l</code>.</li>
<li><code>{do: line x1:... y1:... x2:... y2:... color:...}</code> for a line segment between <code>(x1,y1)</code> and <code>(x2,y2)</code>.</li>
<li><code>{do: rectangle left:... top:... right:... bottom:... color:...}</code> for a rectangle.</li>
<li><code>{do: quadrilateral top_x:... top_y:... right_x:... right_y:... bottom_x:... bottom_y:... left_x:... left_y:... color:...}</code> for a rectangle.</li>
<li><code>{do: circle x:... y:... r:... color:...}</code> for a circle of center <code>(x,y)</code> and radius <code>r</code>.</li>
<li><code>{do: ellipse x:... y:... a:... l:... L:... color:...}</code> for an ellipse of center <code>(x,y)</code> angle <code>a</code> in degree and axes length <code>L</code>, <code>l</code>.</li>
</ul>
</li>
<li>For compatibility reason <code>crop</code> is a synonym of <code>rectangle</code> and <code>rectify</code> is a synonym of <code>quadrilateral</code>.</li>
<li>The color is given as a [w0rgbycm] char for ([w]hite, [0]black, [r]ed, [g]reen, [b]lue, [y]ellow, [c]yan, [m]agenta) color.</li>
</ul>
</li>
<li>
<p><em>Output channel</em>: The <code>draw</code> image with the <code>input</code> image and the drawings.</p>
</li>
</ul>
</li>
<li>
<p><a name="show"></a> <strong>[show]</strong> <code>{ do: show, name: ... channel: ... }</code></p>
<ul>
<li>Displays channel·s in popup window·s.</li>
<li><em>Input channel·s</em>: The channel to show.</li>
<li><em>Input parameters</em>:
<ul>
<li><code>name</code>: Optional image name for the window title.</li>
<li><code>channel</code>: A channel name, default is <code>channel: input</code>.</li>
<li><code>channels</code>: A list of channel names, e.g. <code>channels: [input, edge]</code>, that must have been precalculated.</li>
</ul>
</li>
<li>The <code>Image::waitUntilWindowsClosed()</code> usually called at the end of the <code>int main(int argc, char *argv[])</code> function. wiats utill all display windows are closed.</li>
</ul>
</li>
</ul>
<h2>Caution about bug and caveat <a name="bugs"></a></h2>
<ul>
<li>There is a bug using the opencv while forking processes, the program may block.</li>
</ul>
</div>




























        
        </div>
    

    

    

    
    
    

     

    

    

    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2021-07-04 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>